#include "CBus.h"

#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <fstream.h>


CBus::CBus(char *codigo, char *destino, int capacidad) {

  strcpy(codigo_camion,codigo);
 strcpy(nombre_archivo,codigo);
 strcpy(nombre_destino,destino);
 capacidadMAX = capacidad;
 strcat(nombre_archivo,".txt");
 strcpy(hora,"00:00");
 MAX_EST = 5;
 MAX_NINO = 5;
 MAX_INSEN = 5;
 MAX_MAESTRO = 5;

 tot_adulto = 0;
 tot_estudiante = 0;
 tot_maestro = 0;
 tot_nino = 0;
 tot_insen = 0;

 costo_boleto = 0;

 cout<<endl<<"Construyendo "<<codigo_camion<<"...";
 camion = new CAsiento [capacidadMAX];

 if (!camion) {  cout<<"Error asignaciond de memoria. No se pudo crear arreglo";
   exit(1);    }

 for(int i=0; i< capacidadMAX; i++){
     camion[i].ocupado=0;
     camion[i].num_asiento=i+1;
     camion[i].tipo='x';
     camion[i].costo=0;
     strcpy(camion[i].nombre,"x");  }

 cout<<" Asignados "<<sizeof(camion[0])*capacidadMAX<<" Bytes"; }


CBus::~CBus(){ cout<<endl<<"Destruyendo "<<codigo_camion<<"...";
   delete [] camion;   }


void CBus::guardar(ostream &archivo){
  archivo << "A= " << tot_adulto << endl;
  archivo << "E= " << tot_estudiante << endl;
  archivo << "M= " << tot_maestro << endl;
  archivo << "N= " << tot_nino << endl;
  archivo << "I= " << tot_insen << endl;


  for(int i=0; i< capacidadMAX; i++) {
  archivo << camion[i].num_asiento <<" ";
  archivo << camion[i].tipo <<" ";
  archivo << camion[i].costo <<" ";
  archivo << camion[i].ocupado <<" ";
  archivo << camion[i].nombre<<endl;   } }

// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void CBus::abrir(istream &archivo){
  char buffer[20];

  archivo >> buffer >> tot_adulto;
  archivo >> buffer >> tot_estudiante;
  archivo >> buffer >> tot_maestro;
  archivo >> buffer >> tot_nino;
  archivo >> buffer >> tot_insen;


  for(int i=0; i< capacidadMAX; i++) {
  archivo >> camion[i].num_asiento;
  archivo >> camion[i].tipo;
  archivo >> camion[i].costo;
  archivo >> camion[i].ocupado;
  char ch;
  archivo.get(ch);
  archivo.get(buffer,20);
  strcpy(camion[i].nombre,buffer);    }}


void CBus::fijar_hora(char *h){
 strcpy(hora,h);
}

void CBus::fijar_costo(float costoB){
 costo_boleto = costoB;
}

void CBus::fijar_lugares_descuentos(int est, int nino, int insen, int maestro){
  MAX_EST = est;
  MAX_NINO = nino;
  MAX_INSEN = insen;
  MAX_MAESTRO = maestro; }

char* CBus::show_nombre_archivo(){   return nombre_archivo;   }

char* CBus::show_codigo(){   return codigo_camion; }

char* CBus::show_destino(){   return nombre_destino;     }

char* CBus::show_hora(){     return hora;  }

void CBus::mostrar_datos(){           billetazo();
    cout<<"\n<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<"<<endl;
    cout<<"| Camion       : " << codigo_camion  << endl;
    cout<<"| Destino      : " << nombre_destino << endl;
    cout<<"| Hora Salida  : " << hora  << endl;
    cout<<"| Costo Boleto : $" << costo_boleto << endl;
    cout<<"| Capacidad    : " << capacidadMAX << " asientos"<<endl;
    cout<<"|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"<<endl;
    cout<<"|   Descuentos -  Autorizados  -  Vendidos"<<endl;
    cout<<"|    Adultos     : "<<death_note()<<"\t\t"<<tot_adulto<<endl;
    cout<<"|    Estudiantes : "<<MAX_EST<<"\t\t"<<tot_estudiante<<endl;
    cout<<"|    Nios       : "<<MAX_NINO<<"\t\t"<<tot_nino<<endl;
    cout<<"|    Maestros    : "<<MAX_MAESTRO<<"\t\t"<<tot_maestro<<endl;
    cout<<"|    Insen       : "<<MAX_INSEN<<"\t\t"<<tot_insen<<endl;
    cout<<"|    DINERO TOTAL              "<<J<<endl;
    cout<<"|    asientos ocupados         " <<liberty()<<endl;
    cout<<"|    asientos libres           " <<death_note()<<endl;
    cout<<">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"<<endl;
}

void CBus::ZERUELX(){   clrscr();
TUM();billetazo();
cout<<endl<<"================================================";
cout<<endl<<"<Tipo >     <CanT> <Costo>   <Total>"<<endl;
cout<<"|Adultos     : "<<tot_adulto<<"    "<<costo_boleto<<"         "<<costo_boleto*tot_adulto<<endl;
cout<<"|Estudiantes : "<<tot_estudiante<<"    "<<costo_boleto-(costo_boleto*0.15)<<"       "<<tot_estudiante*(costo_boleto-(costo_boleto*0.15))<<endl;
cout<<"|Nios       : "<<tot_nino<<"    "<<costo_boleto-(costo_boleto*0.5)<<"          "<<tot_nino*(costo_boleto-(costo_boleto*0.5))<<endl;
cout<<"|Maestros    : "<<tot_maestro<<"    "<<costo_boleto-(costo_boleto*0.25)<<"       "<<tot_maestro*(costo_boleto-(costo_boleto*0.25))<<endl;
cout<<"|Insen       : "<<tot_insen<<"    "<<costo_boleto-(costo_boleto*0.7)<<"          "<<tot_insen*(costo_boleto-(costo_boleto*0.7))<<endl;
cout<<"|DINERO TOTAL                   "<<J<<endl; }

int CBus::vender() {
  TUM();
CAsiento aux;
int num, pot;    char  pancita[20];
char tecla;    char paloma[20];

cout<<"seleccione numero de asiento del camion"<<endl;
cin>>num;
if (camion[num-1].ocupado == 1){cout<<"ASIENTO OCUPADO ESCOJA OTRO"; getch();}else{
if (num>capacidadMAX){cout<< "asiento inexistente";getch();}else{
if(num == camion[num-1].ocupado ){
cout<<"asiento ocupado por favor escoja otro";getch();}
  else {
aux.num_asiento = num;
cout<<"ingrese nombre del usuario "<<endl;
cin>>paloma; //por alguna maldita razon get no funciona....
strcpy(aux.nombre,paloma);

cout<<endl<<"seleccione tipo de boleto"<<endl;
cout<<"1 : Adulto"<<endl;
cout<<"2 : Estudiante"<<endl;
cout<<"3 : Maestro"<<endl;
cout<<"4 : Ninio"<<endl;//vil zangano XD
cout<<"5 : Insen"<<endl; // lalaalXD
pot=getch();



 if(pot == '1'){   strcpy(pancita,"ADULTO") ;
 aux.tipo = 'A';  aux.costo = costo_boleto; tot_adulto++;}
 if(pot == '2'){ tot_estudiante++;   strcpy(pancita, "ESTUDIANTE") ;
 aux.tipo = 'E';  aux.costo = costo_boleto-(costo_boleto*0.15);}
 if(pot == '3'){ tot_maestro++; strcpy(pancita, "MAESTRO") ;
 aux.tipo = 'M';  aux.costo = costo_boleto-(costo_boleto*0.25);}
  if(pot == '4'){ tot_nino++; strcpy(pancita, "INFANTE") ;
 aux.tipo = 'N';  aux.costo = costo_boleto-(costo_boleto*0.5);}
 if(pot == '5'){ tot_insen++; strcpy(pancita, "INSEN") ;
  aux.tipo = 'I';  aux.costo = costo_boleto-(costo_boleto*0.7);}

if(tot_estudiante>MAX_EST ){cout<<"promocion estudiante llena";getch(); tot_estudiante--; }
else {if (tot_nino>MAX_NINO){cout<<"promocion nio llena"; tot_nino--;getch();}
else {if (tot_maestro>MAX_MAESTRO){cout<<"promocion maestro llena";tot_maestro--;getch();}
else {if  (tot_insen>MAX_INSEN){cout<<"promocion insen llena";tot_insen--;getch();}
else{

aux.ocupado = 1;
cout<<endl<<"Esta seguro de vender"<<endl;
cout<<"El boleto numero... "<<num<<endl;
cout<<"A nombre de........ "<<aux.nombre<<endl;
cout<<"Al precio de....... "<<aux.costo<<endl;
cout<<"Del tipo........... "<<pancita<<endl;
cout<<"Con destino a...... " << nombre_destino;
cout<<endl<<endl<<"Vender boleto "<<num<<" (s/n)";
tecla=getch();

if (tecla=='s') {camion[num-1]=aux;}
else{
if (pot=='1'){tot_adulto--;}
if (pot=='2'){tot_estudiante--;}
if (pot=='3'){tot_maestro--;}
if (pot=='4'){tot_nino--;}
if (pot=='5'){tot_insen--;}    }     }}  }   }}}      }
// ifs , else tripe else
                      //ya dahueva XD
  return 0;    }


int CBus::cancelar() {
CAsiento aux;
int num;
char tecla;

cout<<"seleccione numero de asiento del camion"<<endl;
cin>>num;


if (camion[num-1].ocupado == 0){cout<<"ASIENTO VACIO NO HACE FALTA"; getch();}else{
if (num>capacidadMAX){cout<< "asiento inexistente";getch();}else{

cout<<endl<<"Esta seguro de cancelar"<<endl;
cout<<"El boleto numero... "<<num<<endl;
cout<<"A nombre de........ "<<camion[num-1].nombre<<endl;
cout<<"Al precio de....... "<<camion[num-1].costo<<endl;
cout<<"Del tipo........... "<<camion[num-1].tipo<<endl;
cout<<"Con destino a...... " << nombre_destino;

cout <<endl<<"Cancelar boleto "<<num<<" (s/n)";
  tecla=getch();

  if (tecla=='s') {
if (camion[num-1].tipo=='A'){tot_adulto--;}
if (camion[num-1].tipo=='E'){tot_estudiante--;}
if (camion[num-1].tipo=='M'){tot_maestro--;}
if (camion[num-1].tipo=='N'){tot_nino--;}
if (camion[num-1].tipo=='I'){tot_insen--;}

     camion[num-1].ocupado=0;
     camion[num-1].tipo='x';
     camion[num-1].costo=0;
     strcpy(camion[num-1].nombre,"x");
  }      }}
  return 0;
}

void CBus::TUM(){
int t=0, r=1,j=0;


textbackground(2); gotoxy(40,2);cprintf("Adulto = %d" ,tot_adulto);
textbackground(3);gotoxy (65,2);cprintf("Estudiante = %d" ,tot_estudiante);
textbackground(4);gotoxy (52,2);cprintf("Maestro = %d" ,tot_maestro);
textbackground(5);gotoxy (52,4);cprintf("Ninio = %d" ,tot_nino);
textbackground(6);gotoxy (40,4);cprintf("Insen = %d" ,tot_insen);
textbackground(7);gotoxy (65,4); textcolor(0);
cprintf("TOTAL = %d" ,(tot_insen+tot_maestro+tot_nino+tot_estudiante+tot_adulto));
 textcolor(7);  textbackground(2) ;

for (int z= 0; z<30;z++){
for (int x= 0; x<18;x++){
textbackground(1);
gotoxy(44+z, 6+x);cprintf(" ");
}            }


for(int p=0;p < capacidadMAX;p++,t++,j++){
   if (t>4){r= r+2;t=0;}
   if (j>9){r= r+1;j=0;}

 gotoxy(45+t*6,5+r*2);


 if(camion[p].tipo == 'A'){textbackground(2);}
 if(camion[p].tipo == 'E'){textbackground(3);}
 if(camion[p].tipo == 'M'){textbackground(4);}
 if(camion[p].tipo == 'N'){textbackground(5);}
 if(camion[p].tipo == 'I'){textbackground(6);}

 cprintf("%d %s", camion[p].num_asiento, &camion[p].tipo);
    textbackground(1);
 textbackground(1);
 gotoxy(48+0*6,5+1*2);cprintf("   ");}
  textbackground(0);gotoxy(1,1);        }



int CBus::liberty(){int p; p=tot_adulto+tot_estudiante+tot_maestro+
tot_nino+tot_insen; return p;}
int CBus::death_note(){int z =capacidadMAX-liberty(); return z;}

void CBus::billetazo(){  int p;
for (int caramelo = 0;  caramelo<capacidadMAX;caramelo++){
 if(camion[caramelo].ocupado==1){ p++;  J=J + camion[caramelo].costo;
  } }if (p==0){J=0;}  }

void CBus::blood(){   billetazo();
cout<<"______________________________________"<<endl;
cout<<"| ASIENTO - NOMBRE -  BOLETO - PRECIO        |"<<endl;
for (int h = 0;h <capacidadMAX;h++){

cout<<"|    "<<h+1<<"       "<<camion[h].nombre<<"          "<<
camion[h].tipo<<"        " <<camion[h].costo<<"    |"<<endl;
}
cout<<"TOTAL                  "<< J;
                                      getch();}
 